(function() {
	'use strict';

	angular.module('ipconfigure.orchid')
		.controller('StreamPreviewCtrl', ['$scope', '$modalInstance', '$rootScope', 'LowBandwidthStreamService', 'stream', StreamPreviewCtrl]);

	function StreamPreviewCtrl($scope, $modalInstance, $rootScope, LowBandwidthStreamService, stream) {
		// TODO not right at all, but the <player> directive is overkill and we have no simple <video> directive yet
		var videoComponent = $rootScope.compatibilityMode ? ipConfigure.components.videoCompatibility : ipConfigure.components.video,
			video,
			destroyed = false,
			cachedLowBandwidthStream;

		setTimeout(function() {
			if (destroyed === false) {
				video = new videoComponent('stream-preview', {
					getTime: function() {
						return Date.now();
					},
					stream: stream,
					requestBaseUrl: function (options, callback) {
						// ask low-bandwidth service for a frame puller thing
						LowBandwidthStreamService.createStream(stream, options, function(success, resource) {
							if (success === true) {
								cachedLowBandwidthStream = resource;

								callback(resource.href + '/frame', resource.fps);
							}
							else {
								callback(false);
							}
						});
					}
				});

				video.playLive();
			}
		}, 250);

		$scope.$on('$destroy', function() {
			if (video) {
				video.stop();
			}

			if (cachedLowBandwidthStream) {
				LowBandwidthStreamService.destroyStream(cachedLowBandwidthStream);
			}

			destroyed = true;
		});

		$scope.cancel = function() {
			$modalInstance.dismiss('cancel');
		};
	}
}());
